#include "gui/status_ui.hpp"
#include "game/components.hpp"
#include <guecs/ui.hpp>
#include "algos/rand.hpp"
#include <fmt/xchar.h>
#include "gui/guecstra.hpp"
#include "game/systems.hpp"
#include "game/inventory.hpp"
#include "game/level.hpp"

namespace gui {
  using namespace guecs;
  using std::any, std::any_cast, std::string, std::make_any;

  StatusUI::StatusUI(size_t x, size_t y, size_t width, size_t height)
  {
    $gui.position(x, y, width, height);
    $gui.layout(
        "[*%(100, 300)body_ui]"
        "[_]"
        "[_]"
        "[=inv0|=inv1|=inv2]"
        "[=inv3|=inv4|=inv5]"
        "[=inv6|=inv7|=inv8]"
        "[=hand_main]"
        "[=hand_off]");
  }

  void StatusUI::init() {
    $gui.set<Background>($gui.MAIN, {$gui.$parser, });

    for(auto& [name, cell] : $gui.cells()) {
      auto gui_id = $gui.entity(name);

      $gui.set<Text>(gui_id, {guecs::to_wstring(name)});

      if(name.starts_with("body_")) {
        auto& cell = $gui.cell_for(name);
        $body_ui.init(cell.x, cell.y, cell.w, cell.h);
      } else {
        $gui.set<Rectangle>(gui_id, {});
        $gui.set<Clickable>(gui_id, {
            guecs::make_action(gui_id, game::Event::INV_SELECT, {gui_id})
        });
        $gui.set<DropTarget>(gui_id, {
            .commit=[&, gui_id](DinkyECS::Entity world_target) -> bool {
            return place_slot(gui_id, world_target);
          }
        });
      }
    }

    $gui.init();
    update();
  }

  bool StatusUI::mouse(float x, float y, guecs::Modifiers mods) {
    return $gui.mouse(x, y, mods);
  }

  void StatusUI::update() {
    auto world = GameDB::current_world();
    auto player = world->get_the<components::Player>();
    auto& inventory = world->get<inventory::Model>(player.entity);

    $body_ui.update();

    for(const auto& [slot, cell] : $gui.cells()) {
      if(inventory.has(slot)) {
        auto gui_id = $gui.entity(slot);
        auto world_entity = inventory.get(slot);

        dbc::check(world->has<components::Sprite>(world_entity),
            fmt::format("inventory {} has missing sprite", slot));

        auto& sprite = world->get<components::Sprite>(world_entity);

        $gui.set_init<guecs::Icon>(gui_id, {sprite.name});

        guecs::GrabSource grabber{ world_entity,
          [&, gui_id]() { return remove_slot(gui_id); }};

        grabber.setSprite($gui, gui_id);

        $gui.set<guecs::GrabSource>(gui_id, grabber);
      } else {
        auto gui_id = $gui.entity(slot);

        if($gui.has<guecs::GrabSource>(gui_id)) {
          $gui.remove<guecs::GrabSource>(gui_id);
          $gui.remove<guecs::Icon>(gui_id);
        }
      }
    }
  }

  void StatusUI::render(sf::RenderWindow &window) {
    $gui.render(window);
    $body_ui.render(window);
    // $gui.debug_layout(window);
  }

  void StatusUI::update_level() {
    init();
  }

  bool StatusUI::place_slot(guecs::Entity gui_id, DinkyECS::Entity world_entity) {
    auto& level = GameDB::current_level();
    auto& slot_name = $gui.name_for(gui_id);
    auto& inventory = level.world->get<inventory::Model>(level.player);

    if(inventory.add(slot_name, world_entity)) {
      level.world->make_constant(world_entity);
      update();
      return true;
    }  else {
      dbc::log("there's something there already");
      return false;
    }
  }

  void StatusUI::drop_item(DinkyECS::Entity item_id) {
    System::drop_item(item_id);
    update();
  }

  // NOTE: do I need this or how does it relate to drop_item?
  void StatusUI::remove_slot(guecs::Entity slot_id) {
    auto player = GameDB::the_player();
    auto& slot_name = $gui.name_for(slot_id);
    System::remove_from_container(player, slot_name);
    update();
  }

  void StatusUI::swap(guecs::Entity gui_a, guecs::Entity gui_b) {
    if(gui_a != gui_b) {
      auto player = GameDB::the_player();
      auto& a_name = $gui.name_for(gui_a);
      auto& b_name = $gui.name_for(gui_b);
      System::inventory_swap(player, a_name, b_name);
    }

    update();
  }

  bool StatusUI::occupied(guecs::Entity slot) {
    auto player = GameDB::the_player();
    return System::inventory_occupied(player, $gui.name_for(slot));
  }
}
